routes/web.php
<?php

use App\Http\Controllers\ProfileController;
use App\Http\Controllers\QuestionsController;
use App\Http\Controllers\AnswersController;
use App\Http\Controllers\FavouritesController;
use App\Http\Controllers\VotesController;
use App\Http\Controllers\UsersController;





use Illuminate\Support\Facades\Route;

Route::get('/', function () {
    return view('welcome');
});

Route::get('/dashboard', function () {
    return view('dashboard');
})->middleware(['auth', 'verified'])->name('dashboard');

Route::middleware('auth')->group(function () {
    Route::get('/profile', [ProfileController::class, 'edit'])->name('profile.edit');
    Route::patch('/profile', [ProfileController::class, 'update'])->name('profile.update');
    Route::delete('/profile', [ProfileController::class, 'destroy'])->name('profile.destroy');
});

require __DIR__.'/auth.php';

Route::resource('questions', QuestionsController::class)->except(['show']);
Route::get('/questions/{slug}', [QuestionsController::class,'show'])->name('questions.show');

Route::resource('questions.answers', AnswersController::class)->except(['show','index','create']);
Route::put('/questions/{question}/answers/{answer}/markAsBest',[AnswersController::class,'markAsBest'])->name('questions.answers.markAsBest');
 Route::post('/questions/{question}/mark-as-fav',[FavouritesController::class,'store'])->name('questions.favourite');
 Route::delete('/questions/{question}/mark-as-unfav',[FavouritesController::class,'destroy'])->name('questions.unfavourite');
 Route::post('/questions/{question}/vote/{vote}',[VotesController::class,'voteQuestion'])->name('questions.vote');

 Route::get('users/notifications',[UsersController::class,'notifications'])->name('users.notifications');

app/Models/Answer.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Attributes\ObservedBy;
use App\Observers\AnswerObserver;


class Answer extends Model
{   protected $guarded = [];

    use HasFactory;

    //

    #[ObservedBy([AnswerObserver::class])]

    public function question()
    {
        return $this->belongsTo(Question::class);
    }

    public function author()
    {
        return $this->belongsTo(User::class,'user_id');
    }
    public function getCreatedDateAttribute()
    {
        return $this->created_at->diffForHumans();
    }

    public function getBestAnswerStyleAttribute()
    {
        return $this->question->best_answer_id === $this->id ? 'text-success' : '';
    }
    public function getisBestAttribute()
    {
        return $this->question->best_answer_id === $this->id ;

    }




}

app/Models/User.php
<?php

namespace App\Models;

// use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * Get the attributes that should be cast.
     *
     * @return array<string, string>
     */
    protected function casts(): array
    {
        return [
            'email_verified_at' => 'datetime',
            'password' => 'hashed',
        ];
    }
    public function questions()
    {
        return $this->hasMany(Question::class);
    }

    public function answers()
    {
        return $this->hasMany(Answer::class);
    }

    public function favourites()
    {
        return $this->belongsToMany(Question::class)->withTimestamp();
    }

    public function votesQuestions()
    {
        return $this->morphedByMany(Question::class,'vote')->withTimestamps();
    }

    public function votesAnswers()
    {
        return $this->morphedByMany(Answer::class,'vote')->withTimestamps();
    }
    public function hasUpVoteForQuestion(Question $question)
    {
        return $this->votesQuestions()->where(['vote'=> 1,'vote_id' => $question->id])->exists();
    }

    public function hasDownVoteForQuestion(Question $question)
    {
        return $this->votesQuestions()->where(['vote'=> -1,'vote_id' => $question->id])->exists();
    }
    public function hasVoteForQuestion(Question $question)
    {
        return $this->hasUpVoteForQuestion($question) || $this->hasDownVoteForQuestion($question);
    }
    public function getAvatarAttribute()
    {
        $size =40;
        return "https://ui-avatars.com/api/?name={$this->name}&rounded=true&size={$size}";
    }
}

app/Http/Controllers/AnswersController.php
<?php

namespace App\Http\Controllers;

use App\Models\Answer;
use App\Models\Question;
use App\Notifications\NewReplyAdded;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Gate;
use App\Http\Requests\Answer\CreateAnswerRequest;
use App\Http\Requests\Answer\UpdateAnswerRequest;



class AnswersController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index()
    {
        //
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(CreateAnswerRequest $request, Question $question)
    {
        $question->answers()->create([
            'body'=> $request->body,
            'user_id'=>auth()->id()
        ]);
        $question->owner->notify(new NewReplyAdded($question));

        session()->flash('success','Your answer submitted successfully!');
        return redirect($question->url);
    }


    /**
     * Display the specified resource.
     */
    public function show(Answer $answer)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Question $question,Answer $answer)
    {   Gate::authorize('update',$answer);
        return view('qa.answers.edit',compact(['question','answer']));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(UpdateAnswerRequest $request,Question $question, Answer $answer )
    {
        Gate::authorize('update',$answer);
        $answer->update(['body'=>$request->body]);

        session()->flash('success','Your answer has been updated successfully!');
        return redirect($question->url);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Question $question,Answer $answer)
    {
        Gate::authorize('delete',$answer);
        $answer->delete();
        session()->flash('success','Your answer has been deleted successfully!');
        return redirect($question->url);
    }
    public function markAsBest(Question $question,Answer $answer)

    {   Gate::authorize('markAsBest',$answer);
        $answer->question->markBestAnswer($answer);
        return redirect()->back();

    }
}

resources/views/qa/answers/_create.blade.php
<div class="row t-4 justify-content-center">
    <div class="col-md-12">
        <div class="card">
            <div class="card-header">
                <h3>Your answer</h3>
            </div>
            <div class="card-body">
                <form action="{{ route('questions.answers.store',$question->id)}}" method="POST">
                    @csrf
                    <div class="form-group mb-4">
                        <input id="body" type="hidden" name="body" value="{{ old('body')}}">
                        <trix-editor input="body" class="form-control {{ $errors->has('body') ? 'is-invalid' : ''}}"></trix-editor>
                        @error('body')
                            <div class="text-danger text-sm">{{ $message }}</div>
                        @enderror
                    </div>
                    <div class="form-group">
                        <button type="submit" class="btn btn-outline-primary">Submit</button>
                    </div>
                </form>
            </div>
            <div class="card-footer">

            </div>
        </div>
    </div>
</div>

resources/views/qa/answers/_index.blade.php
<div class="row mt-4">
<div class="col-md-12">
    <div class="card">
        <div class="card-header">
            <h3>{{ Str::plural('Answer', $question->answers_count) }}</h3>
        </div>
        <div class="card-body">
            @foreach ($question->answers as $answer)
                {!! $answer->body !!}
                <div class="d-flex justify-content-between mr-3">
                    <div class="d-flex">
                        <div>
                            @can('update',$answer)

                            <a href="{{ route('questions.answers.edit',[$question,$answer])}}"  class="btn btn-outline-warning btn-sm">
                                Edit
                            </a>
                            @endcan

                            @can('delete',$answer)
                                <form action="{{ route('questions.answers.destroy',[$question,$answer])}}" method="POST" class="d-inline-block">
                                    @csrf
                                    @method('DELETE')
                                    <button type="submit" class="btn btn-outline-danger btn-sm">Del</button>
                                </form>

                            @endcan
                            <a href="#" title="Up Vote" class="vote-up d-block text-center text-dark">
                                <i class="fa fa-caret-up fa-3x"></i>
                            </a>
                            <h4 class="votes-count textmuted text-center m-0">{{ $answer->votes_count }} </h4>
                            <a href="#" title="Down Vote" class="vote-up d-block text-center text-dark">
                                <i class="fa fa-caret-down fa-3x"></i>
                            </a>
                        </div>
                        <div class="m-4">
                            @can('markAsBest',$answer)
                            <form action="{{ route('questions.answers.markAsBest',[$question,$answer]) }}" method="POST">
                            @csrf
                            @method('PUT')
                            <button type="submit" class="btn">
                                <i class="fa fa-check fa-2x {{ $answer->best_answer_style }}"></i>
                            </button>
                        </form>

                        @else
                            @if($answer->is_best)
                            <i class="fa fa-check fa-2x {{ $answer->best_answer_style }}"></i>
                            @endif
                        @endcan
                        </div>
                    </div>
                    <div class="d-flex flex-column">
                        <div class="text-muted mb-2 text-right">
                            Answered At: {{ $answer->created_date }}
                        </div>
                        <div class="d-flex mb-2">
                            <div>
                                <img src="{{ $answer->author->avatar }}"
                                    alt="Avatar of  {{ $answer->author->name }}">
                            </div>
                            <div class="m-2">
                                {{ $answer->author->name }}
                            </div>
                        </div>
                    </div>
                </div>
                <hr>
            @endforeach
        </div>
    </div>
</div>
</div>

resources/views/qa/answers/edit.blade.php
@extends('qa.layouts.app')

@section('page-level-styles')
    <link rel="stylesheet" type="text/css" href="https://unpkg.com/trix@2.0.8/dist/trix.css">
@endsection

@section('page-level-scripts')
    <script type="text/javascript" src="https://unpkg.com/trix@2.0.8/dist/trix.umd.min.js"></script>
@endsection

@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header">
                        <h3>Edit Answer!</h3>
                    </div>
                    <div class="card-body">
                        <form action="{{ route('questions.answers.update', [$question->id, $answer->id]) }}" method="POST"
                            enctype="multipart/form-data">
                            @csrf
                            @method('PUT')
                            <div class="form-group mb-4">
                                <input id="body" type="hidden" name="body"
                                    value="{{ old('body', $answer->body) }}">
                                <trix-editor input="body"
                                    class="form-control {{ $errors->has('body') ? 'is-invalid' : '' }}"></trix-editor>
                                @error('body')
                                    <div class="text-danger text-sm">{{ $message }}</div>
                                @enderror
                            </div>


                            <div class="form-group">
                                <button type="submit" class="btn btn-outline-primary">Submit</button>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection